# Optain Demo Version

# Release Note

## 2025.01.24(Fri) - v0.8.6

## Additional features

- Allows you to set startup programs and check their version
- Supports light/dark mode depending on user theme environment
- Gesture popup can use widgets registered in context popup
- File browsing window available in gesture popup
- Provides information in the bottom description showing each mapped feature with the mapped feature rather than just a name
- Added categories to the right panel of the gesture popup and added descriptions to each item
- Reflect default settings for initial users
  - Gesture popup: feature mapping in 8 directions
  - Context popups: translation, summarize, query search, and text compose alternative widgets
- Renamed mouse special buttons as 4th and 5th buttons

## Bug fixes

- Fixed broken design due to context popup character length
- Fixed Cloud Search integration issues (`macOS` not available, `Google` login issues)
  - Disabled support for signing in to Microsoft Office services on `macOS`.
- Fixed an issue where emoji settings would sometimes not turn off in the Shortcut Settings window
  - Eliminated an issue where pressing the `ESC` key on the Customize Hotkeys screen at the same time would cause the screen to turn off without mapping
- Fixed a bug on `macOS` that sometimes focused on the previous program (usually `Finder`)
- Fixed a bug where events were sometimes ignored when `Trigger Event` was set to Ignore on `macOS`.
- Removed unnecessary math, display of Korean characters, and unnecessary area in search bar
- Fixed not being able to map basic functions with clicks

### Currently identified bugs

- Preview icon does not change (reflect) immediately when mapping with a click

## Development in progress

1. Program Recognition
2. Enable gestures with Logitech devices
3. magic mouse and trackpad integration on macOS
4. mouse wheel reversal
5. macro enhancements
6. added gesture popup templates/states
7. specialized UI for each operating system

---

## 2024.12.10(Tue) - v0.8.5

## Additional features

- Focus on each input element directly when the mapping window is turned on
- Added the ability to record macro functions and add them to the mapping window
- Enabled mouse click/move/scroll in macro functions
- Updated some styling details

## Bug fixes

- Remove titles from top tray on `macOS` (show icons only)
- In text input function, long text is missing and entered incorrectly
- Fixed context popups appearing in strange places under certain conditions

### Currently identified bugs

- Critical bug in `AI` related feature widget, currently unavailable (being fixed)
- Not running properly when running on `macOS` without ignoring mouse input
- When pressing `ESC` in the mapping window, the wrong window would be turned off
- On `macOS`, the `Finder` would keep trying to focus on the mouse.

## Development in progress

1. Program Recognition
2. Enable gestures with Logitech devices
3. magic mouse and trackpad integration on macOS
4. mouse wheel reversal
5. macro enhancements
6. added gesture popup templates/states
7. specialized UI for each operating system
8. default settings.

---

## 2024.11.26(Tue) - v0.8.4

## Additional features

- Renewed the `UI` of the gesture popup from a circle to a doughnut.
  - What is displayed in the donut is icons, all of which need to be set up anew
    - Emoji can be utilized as icons
    - You can also upload your own `.png`, `jpg`, and `.jpeg` files
  - Shortcuts that were mapped in previous versions don't have icons, so they all display '⚠️'
  - Include icons for built-in keys
- Added combination hotkey preview design
- Added some built-in features for `Windows` and `macOS` respectively
- Change the window first-time setup screen gesture settings
- UX changes to allow gestures to be executed without ignoring the trigger key if dragged right away

## Bug fixes

- Fixed `Launchpad` and `Mission Control` running in reverse on `macOS`.
- Fixed some colors in settings design
- Fixed `ESC` not deselecting when typing in gesture settings on `Windows`

### Currently confirmed bugs

- Context popup in strange places on some computers when using dual monitors

## Development in progress

1. Setting up a Macro with Recording
2. Program Recognition
3. Enable gestures with Logitech devices
4. Dedicated plug-in widget for Adobe Premiere Pro
5. magic mouse and trackpad integration on macOS
6. mouse wheel reversal
7. add mouse functionality

## 2024.11.15(Fri) - v0.8.3

## Additional features

- Change default settings for both popups with a mouse wheel click
- Added support for special key emoji for the hotkeys settings feature
- Apply dark transparency to gestures to make them more visible on white backgrounds

## Bug fixes

- Fixed bug when registering/unregistering hotkeys could not be set due to error
- Removed gesture popup circular afterimage
- Changed some Korean to English
- Fixed system search function not working within macro mapping

### Currently confirmed bugs

- Context popup in strange places on some computers when using dual monitors

## Development in progress

1. modify the gesture design
2. Enable gestures with Logitech devices
3. Dedicated plug-in widget for Adobe Premiere Pro
4. magic mouse and trackpad integration on macOS
5. mouse wheel reversal
6. add mouse functionality

---

## 2024.11.13(Wed) - v0.8.2

## Additional features

- Gesture popup can also be triggered by keyboard shortcut
- Immediate execution of functions when moving a long distance from a gesture (execute before pressing and releasing)
- Subtitle mouse special keystrokes (forward, backward)

## Bug fixes

- Fixed system keys not working, such as volume control
- Fixed bug where gesture input was sometimes ignored on macOS
- Can use `Windows` key as keyboard shortcut when registering context / gesture popup trigger
- Fixed 'Time delay' in Korean to 'Delay'

### Currently confirmed bugs

- Gesture execution key rolls back to previous setting when changing the number of gesture functions (visibly)
- Context popup in strange places on some computers when using dual monitors

## Development in progress

1. fix gesture design
2. make gesture click alone to launch function
3. Plugin widget for `Adobe Premiere Pro` only
4. magic mouse, trackpad integration on `macOS`, etc.

---

## 2024.11.08(Fri) - v0.8.1

## Additional features

- Pop-ups can appear on any screen on `macOS
- Remove background for gesture popups
- Prevent empty values from being entered when using `Open URL` in gestures
- Settings window from tray icon now focuses on window if already on when turned on
- Restart the app from the tray icon

## Bug fixes

- Fixed folder turning on when running empty value with `Open URL` in gesture
- Fixed a bug on `macOS` where some special symbols or numbers would cause a force close
- Fixed a bug where the last function executed with a gesture popup was repeatedly executed with a context popup
- Fixed a bug where gesture pop-ups would crash while being used

### Currently confirmed bugs

- Gesture popup not working while running with mouse -> restart required from tray icon
- Gesture popup does not support launching with keyboard

## Development in progress

1. fix gesture design
2. execute gesture with keyboard
3. execute function immediately when moving more than a certain distance from gesture
4. make it so that clicking on the gesture is enough to launch the function
5. plugin widget for `Adobe Premiere Pro` only

---

## 2024.11.06(Wed) - v0.8.0

### Developments

- Temporary support for `macOS
- Added AI answers based on local and cloud file contents
- Added gesture functionality
- Added `Google Slides`, `Google Calendar`
- Changed the installation file from `.exe` to `.msi` (previously downloaded versions should be uninstalled)
- Change to utilize search bar
- Context popup length dynamically changed based on number of widgets
- Launch widgets with a special combination of `Ctrl`, `Cmd`
- Improved local and cloud file search hit rate and UX fixes
- Fix to prevent multiple `Optain` from running at the same time
- Improved stability of cloud file account integration
- Removed the need to install the widget separately

### Currently confirmed bugs

- Gesture popup mouse not working while running
- Gesture popup does not work while running with mouse
- Gesture popup does not support launching with keyboard
- Gestures do not hide mouse cursor on macOS
- Special symbols such as `[`, `]`, `/`, `\`, `,`, `.`, `=`, `-`, `;`, `'`, `, ``` cannot be used in gestures on `macOS`, etc.

---

## 2024.09.23(Mon) - v0.7.0

### Developments

- Added local and cloud file search function
- Fixed bug when changing the order with `Drag & Drop` in widget settings
  - Fixed a location issue when `Drag & Drop` occurs
- Move to bottom of widget disabled by condition
- Improved `UX` of tag search via `/` key in search query widget
- Save search query widget tag state
- focus directly on input window when search curry widget is on
- Fixed some widget activation conditions
  - Summary widget: Dragging more than 20 characters
  - Compose widget: dragging more than 10 characters
  - Query search widget: Not utilizing clipboard data
- Updated folder names for widgets

### Currently confirmed bugs

- Force quit while running with context popup mouse.

---

## 2024.08.26(Mon) - v0.6.1

### Developments

- Added save documentation widget state and add/delete speech patterns
- Added bottom-right notification when widget gets contextual information
- Modified `Cache-Control` to prevent widget from being cached
- Fixed animation when closing context popup
- Modified the delay when context popup is turned on from `0.1s` to `0.4s`.
- Fixes speech in `Optain` applications and widgets (Helper)

### Currently confirmed bugs

- Context popup crashes while running with mouse.

---

## 2024.08.18(Mon) - v0.6.0

### Developments

- Added context trigger functionality by registering hotkeys
- Implemented widget state saving (apply translation widget)
- Exit context popup on click outside context popup
- Completed development of search query widget
- Removed `AI` search service widget, YouTube summary widget
- Always on widget / Widget resizable
- Changed translation widget support to 11 languages (Hindi is not supported by `DeepL`)

### Currently confirmed bugs

- Force close with lag during context popup launch (less frequently)
- Context information may not be passed on when triggering context with hotkeys (caused by special key and copy happening at the same time)

---

## 2024.08.07(Wed) - v0.5.0

### Development

- Completed development of demo version specification defined in `Figma`.
  1. translation widget
  2. summary widget
  3. compose widget
  4. YouTube summary widget (added)
  5. AI search service widget (added)
- Context popups can be interacted with using the keyboard
- Widgets registered for context popups are not saved (reset when turned off)
- No settings for gesture popups, but you can still use the settings from previous versions

### Currently confirmed bugs

- Context popup crashes with lag while running
- Dragging data sometimes doesn't go over when launching context popup (widget result window) after dragging
